from dune.perftool.generation import backend
from dune.perftool.options import get_option
from dune.perftool.pdelab.geometry import (name_jacobian_determinant,
                                           name_jacobian_inverse_transposed)
import pymbolic.primitives as prim


@backend(interface="pymbolic_jacobian_determinant", name="blockstructured")
def pymbolic_jacobian_determinant():
    return prim.Quotient(prim.Variable(name_jacobian_determinant()),
                         prim.Power(get_option("number_of_blocks"),2))


@backend(interface="pymbolic_jacobian_inverse_transposed", name="blockstructured")
def pymbolic_jacobian_inverse_transposed(i,j,restriction):
    return prim.Product((get_option("number_of_blocks"),
                         prim.Subscript(prim.Variable(name_jacobian_inverse_transposed(restriction)), (j, i))))
