from dune.perftool.generation import (iname,
                                      domain)
from dune.perftool.pdelab.geometry import world_dimension
from dune.perftool.generation.counter import get_counted_variable
from dune.perftool.options import get_option
import pymbolic.primitives as prim


@iname
def sub_element_inames():
    name = "subel"
    dim = world_dimension()
    inames = tuple()
    for i in range(dim):
        name_counted = get_counted_variable(name)
        inames = inames + (name_counted,)
        domain(name_counted, get_option("number_of_blocks"))
    return inames

# TODO 3d
def micro_index_to_macro_index(index):
    if not isinstance(index, prim.Variable):
        index = prim.Variable(index)

    subelem_inames = sub_element_inames()

    k = get_option("number_of_blocks")

    modified_index = prim.Product(((k+1), prim.Variable(subelem_inames[1])))
    modified_index = prim.Sum((modified_index, prim.Variable(subelem_inames[0]), index))
    index_div_2 = prim.FloorDiv(index, 2)
    index_div_2 = prim.Product((index_div_2, k-1))
    modified_index = prim.Sum((modified_index, index_div_2))

    return modified_index

